package com.prolog.eis.service.outbound.impl;

import com.prolog.eis.dao.outbound.BizOutboundTaskDetailItemHisMapper;
import com.prolog.eis.model.out.BizOutboundTaskDetailItemHis;
import com.prolog.eis.service.outbound.BizOutboundTaskDetailItemHisService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库物料订单详情表-服务实现类
 * @date 2023-10-12 10:44
 */
@Service
public class BizOutboundTaskDetailItemHisServiceImpl implements BizOutboundTaskDetailItemHisService {

    @Autowired
    private BizOutboundTaskDetailItemHisMapper bizOutboundTaskDetailItemHisMapper;

    /**
     * 新增数据
     *
     * @param bizOutboundTaskDetailItemHis 出库物料订单详情表
     */
    @Override
    public long save(BizOutboundTaskDetailItemHis bizOutboundTaskDetailItemHis) {
        return bizOutboundTaskDetailItemHisMapper.save(bizOutboundTaskDetailItemHis);
    }

    /**
     * 新增批量数据
     *
     * @param bizOutboundTaskDetailItemHisList 出库物料订单详情表
     */
    @Override
    public long saveBatch(List<BizOutboundTaskDetailItemHis> bizOutboundTaskDetailItemHisList) {
        return bizOutboundTaskDetailItemHisMapper.saveBatch(bizOutboundTaskDetailItemHisList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailItemHis> findByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemHisMapper.findByMap(paramMap, BizOutboundTaskDetailItemHis.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public BizOutboundTaskDetailItemHis findOneByMap(Map<String, Object> paramMap) {
        List<BizOutboundTaskDetailItemHis> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailItemHis> findByCriteria(Criteria criteria) {
        return bizOutboundTaskDetailItemHisMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BizOutboundTaskDetailItemHis findById(int id) {
        return bizOutboundTaskDetailItemHisMapper.findById(id, BizOutboundTaskDetailItemHis.class);
    }

    /**
     * 修改数据
     *
     * @param bizOutboundTaskDetailItemHis 实例对象
     */
    @Override
    public long update(BizOutboundTaskDetailItemHis bizOutboundTaskDetailItemHis) {
        return bizOutboundTaskDetailItemHisMapper.update(bizOutboundTaskDetailItemHis);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return bizOutboundTaskDetailItemHisMapper.deleteById(id, BizOutboundTaskDetailItemHis.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemHisMapper.deleteByMap(paramMap, BizOutboundTaskDetailItemHis.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemHisMapper.findCountByMap(paramMap, BizOutboundTaskDetailItemHis.class);
    }
}
